#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include <Arduino.h>

typedef enum eSystem_Status
{
  sysStat_Startup,
  sysStat_Normal,
  sysStat_Rain,
  sysStat_Purge,
  sysStat_Error,
  sysStat_Shutdown
} tSystem_Status;

typedef enum eEERequest
{
  EE_IDLE,
  EE_CFG_SAVE,
  EE_CFG_LOAD,
  EE_PDS_SAVE,
  EE_PDS_LOAD
} tEERequest;

typedef struct Globals_s
{
  tSystem_Status systemStatus = sysStat_Startup;
  tSystem_Status resumeStatus = sysStat_Startup;
  char systemStatustxt[16] = "";
  uint8_t purgePulses = 0;
  eEERequest requestEEAction = EE_IDLE;
  char DeviceName[33];
} Globals_t;

extern Globals_t globals;

#endif